
#include "main.h"
#include "tcp_recv.h"
#include "file_write.h"
#include "windows.h"

int Exit, Save;
int Port;
FILE *fp_log;

//==========================================================================
// KeyInput
//--------------------------------------------------------------------------
// simple thread to monitor key input
//==========================================================================
DWORD WINAPI KeyInput(LPVOID arg) {
	printf("\n\nKeyInput\n\n");
	while (1) {
		char ch = getchar();
		printf("KeyInput %02x\n", ch);
		//fprintf(fp_log, "KeyInput %02x\n", ch);
		if ((ch == 0x0A) || (ch == 0x0D)) {
			// CR
			Save = 1;
		}
		else {
			Exit = 1;
			return 0;
		}

		Sleep(100);
	}
}

//==========================================================================
// main
//==========================================================================
int main(int argc, char** argv)
{
	//-----------------------------------------------------------------
	// ϐ錾
	//-----------------------------------------------------------------
	HANDLE hThread1, hThread2, hThread3;
	DWORD dwThreadId1, dwThreadId2, dwThreadId3;

	Exit = 0;
	Save = 1; // first frame is always saved

	//-----------------------------------------------------------------
	// argument check
	//-----------------------------------------------------------------
	// set port number from argument, default to 5001
	int idx = 0;
	Port = 0;
	if (argc >= 2) {
		printf("argv[1] %s\n", argv[1]);
		while (argv[1][idx] != 0) {
			Port *= 10;
			Port += argv[1][idx] - '0';
			idx++;
		}
	}
	else {
		Port = 5001;
	}
	printf("Port %d\n", Port);

	//-----------------------------------------------------------------
	// log file
	//-----------------------------------------------------------------
	fp_log = fopen("log.txt", "w");
	if (fp_log == 0) {
		printf("failed to open log.txt\n");
		cv::waitKey(0);
		return 0;
	}

	//-----------------------------------------------------------------
	// start threads
	//-----------------------------------------------------------------
	/*
	HANDLE CreateThread(
		LPSECURITY_ATTRIBUTES lpThreadAttributes,
		DWORD dwStackSize,
		LPTHREAD_START_ROUTINE lpStartAddress,
		LPVOID lpParameter,
		DWORD dwCreationFlags,
		LPDWORD lpThreadId
	);
	*/
	hThread1 = CreateThread(
		NULL,			// security attributes
		0,				// stack size
		KeyInput,		// thread function
		NULL,			// parameter to be passed to thread function
		CREATE_SUSPENDED,	// creation flag (0 or CREATE_SUSPENDED)
		&dwThreadId1	// thread ID
	);
	hThread2 = CreateThread(
		NULL,
		0,
		TcpRecvWorker,
		NULL,
		CREATE_SUSPENDED,
		&dwThreadId2
	);
	hThread3 = CreateThread(
		NULL,
		0,
		FileWriteWorker,
		NULL,
		CREATE_SUSPENDED,
		&dwThreadId3
	);

	/*
	THREAD_PRIORITY_TIME_CRITICAL
	THREAD_PRIORITY_HIGHEST
	THREAD_PRIORITY_ABOVE_NORMAL
	THREAD_PRIORITY_NORMAL
	THREAD_PRIORITY_BELOW_NORMAL
	THREAD_PRIORITY_LOWEST
	THREAD_PRIORITY_IDLE
	*/
	SetThreadPriority(hThread1, THREAD_PRIORITY_BELOW_NORMAL);

	ResumeThread(hThread1);
	ResumeThread(hThread2);
	ResumeThread(hThread3);

	//-----------------------------------------------------------------
	// post process
	//-----------------------------------------------------------------
	// wait for thread to quit
	WaitForSingleObject(hThread2, INFINITE);

	// close thread handles
	CloseHandle(hThread1);
	CloseHandle(hThread2);
	CloseHandle(hThread3);

	fclose(fp_log);

	return 0;
}
